// Sam Young Kim
// Caryn Bell
// Thomas Feiler
// CPS108

#ifndef _NAMEFILTER_H
#define _NAMEFILTER_H

#include <re_comp.h>
#include <string>
#include <iostream.h>

class NameFilter: public Filter
{
  public:
    NameFilter(string bnd)
	: myBound(ConvertToRegex(bnd))
	{}  // constructor
    
    virtual void Check(DirEntryPlus & dep) const
	{
        // this is modeled after the sample regex program
        // given to us on the web page
	    char * retval;
	    if((retval = re_comp(myBound.c_str()))==0)
	    {
		if(re_exec(dep.Name().c_str()) != 1)
                // if the entry does not meet the specified
                // NameFilter (which has been converted to a 
                // regular expression), exclude it
		{
		    dep.isFiltered = false;
		}
	    }
	}
	    
    string ConvertToRegex(string bnd)
    // precondition: gets a string such as "*.cc" or "fo*.h"
    // postcondition: returns a string that is a regular expression
    //                of the user specified criteria.  For example, 
    //                "*.cc" is converted to "^.*\.cc$" and returned
	{
	    int len = bnd.length();
	    int i;
            // begin each string with the '^' character
	    string regex = "^";
	    for(i=0; i<len; i++)
	    {
		if(bnd[i]=='*')
		    regex += ".*";
		else if(bnd[i]=='.')
		    regex += "\\.";
		else if(bnd[i]=='$')
		    regex += "\\$";
		else if(bnd[i]=='^')
		    regex +="\\^";
		else
		    regex+= bnd[i];
	    }
	    regex+= '$'; // terminate the string
	    return regex;
	}
    
  private:
    string myBound; // regex expression
    
};

#endif
